'use strict';

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

/**
 * Defines variables used by webpack.DefinePlugin
 *
 * @param {Object} variables
 * @param {Object} predefined
 * @returns {Object}
 */
module.exports = function defineVariables(variables, predefined = {}) {
  if (!Object.keys(variables).length) {
    return {};
  }

  return Object.keys(variables).reduce((result, key) => {
    let value = variables[key];

    if (typeof value !== 'string' && value !== undefined) {
      value = String(value);
    }

    return _extends({}, result, {
      [key]: JSON.stringify(value)
    });
  }, defineVariables(predefined));
};